import { BaseOptions, BasePaginatedOptions, BaseResult, LoadMoreFormatReturn, LoadMoreOptions, LoadMoreOptionsWithFormat, LoadMoreParams, LoadMoreResult, OptionsWithFormat, PaginatedFormatReturn, PaginatedOptionsWithFormat, PaginatedParams, PaginatedResult } from './types';
import useAsync from './useAsync';
import usePaginated from './usePaginated';
import useLoadMore from './useLoadMore';
declare function useAPI<R, P extends any[], U, UU extends U = any>(service: (...args: P) => Promise<R>, options: OptionsWithFormat<R, P, U, UU>): BaseResult<U, P>;
declare function useAPI<R, P extends any[]>(service: (...args: P) => Promise<R>, options?: BaseOptions<R, P>): BaseResult<R, P>;
declare function useAPI<R, Item, U extends Item = any>(service: (...params: LoadMoreParams) => Promise<R>, options: LoadMoreOptionsWithFormat<R, Item, U>): LoadMoreResult<Item>;
declare function useAPI<R, Item, U extends Item = any>(service: (...params: LoadMoreParams) => Promise<LoadMoreFormatReturn<Item>>, options: LoadMoreOptions<U>): LoadMoreResult<Item>;
declare function useAPI<R, Item, U extends Item = any>(service: (...params: PaginatedParams<U>) => Promise<R>, options: PaginatedOptionsWithFormat<R, Item, U>): PaginatedResult<Item>;
declare function useAPI<R, Item, U extends Item = any>(service: (...params: PaginatedParams<U>) => Promise<PaginatedFormatReturn<Item>>, options: BasePaginatedOptions<U>): PaginatedResult<Item>;
export { useAsync, usePaginated, useLoadMore };
export default useAPI;
