"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _useAsync2 = _interopRequireDefault(require("./useAsync"));

var _react = require("react");

var _useUpdateEffect = _interopRequireDefault(require("./utils/useUpdateEffect"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _nonIterableRest(); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function useLoadMore(service, options) {
  var _options$refreshDeps = options.refreshDeps,
      refreshDeps = _options$refreshDeps === void 0 ? [] : _options$refreshDeps,
      fetchKey = options.fetchKey,
      restOptions = _objectWithoutProperties(options, ["refreshDeps", "fetchKey"]);

  (0, _react.useEffect)(function () {
    if (fetchKey) {
      console.warn("useAPI loadMore's fetchKey will not work!");
    }
  }, []);

  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      loadingMore = _useState2[0],
      setLoadingMore = _useState2[1];

  var _useAsync = (0, _useAsync2.default)(service, _objectSpread({}, restOptions, {
    fetchKey: function fetchKey(nextId) {
      // 仅仅为了让 nextId 变成字符串，保证 object 的顺序
      return nextId + '-';
    },
    onSuccess: function onSuccess() {
      setLoadingMore(false);
    }
  })),
      data = _useAsync.data,
      run = _useAsync.run,
      params = _useAsync.params,
      reset = _useAsync.reset,
      loading = _useAsync.loading,
      fetches = _useAsync.fetches,
      rest = _objectWithoutProperties(_useAsync, ["data", "run", "params", "reset", "loading", "fetches"]);

  var reload = (0, _react.useCallback)(function () {
    reset();

    var _params = _toArray(params),
        _ = _params[0],
        rest = _params.slice(1);

    run.apply(void 0, [undefined].concat(_toConsumableArray(rest)));
  }, [run, reset, params]);
  var reloadRef = (0, _react.useRef)(reload);
  reloadRef.current = reload;
  /* loadMore 场景下，如果 refreshDeps 变化，重置到第一页 */

  (0, _useUpdateEffect.default)(function () {
    /* 只有自动执行的场景， refreshDeps 才有效 */
    if (!options.manual) {
      reloadRef.current();
    }
  }, _toConsumableArray(refreshDeps));
  var dataGroup = (0, _react.useMemo)(function () {
    var listGroup = [];
    Object.values(fetches).forEach(function (h) {
      var _h$data;

      if ((_h$data = h.data) === null || _h$data === void 0 ? void 0 : _h$data.list) {
        var _h$data2;

        listGroup = listGroup.concat((_h$data2 = h.data) === null || _h$data2 === void 0 ? void 0 : _h$data2.list);
      }
    });
    return _objectSpread({}, data, {
      list: listGroup
    });
  }, [fetches, data]);
  var loadMore = (0, _react.useCallback)(function () {
    setLoadingMore(true);

    var _params2 = _toArray(params),
        _ = _params2[0],
        rest = _params2.slice(1);

    run.apply(void 0, [data.nextId].concat(_toConsumableArray(rest)));
  }, [run, data, params]);
  return _objectSpread({
    data: dataGroup,
    run: run,
    params: params,
    reset: reset,
    loading: loading && dataGroup.list.length === 0,
    loadMore: loadMore,
    loadingMore: loadingMore,
    fetches: fetches
  }, rest);
}

var _default = useLoadMore;
exports.default = _default;